;SMS sound (PSG) macros

.DEFINE PSG_PORT $7F


;Macro to turn off all sound
.MACRO psg_silence

	ld A, %10011111 ;Mute volume on all channels
	out ($7f), A
	ld A, %10111111
	out ($7f), A
	ld A, %11011111
	out ($7f), A
	ld A, %11111111
	out ($7f), A
	
.ENDM

;Macro to set volume and tone of channel
;Input 1: channel 
;Input 2: tone
;Input 3: volume
.MACRO psg_channel_set ARGS CHAN, TONE, VOL
	
	ld A, %10000000 | (TONE & $0f) | ((CHAN & $03) << 5) ;low bits of tone
	out ($7f), A
	
	ld A, %00000000 | ((TONE >> 4) & $3f) ;high bits of tone
	out ($7f), A
	
	ld A, %10010000 | (VOL & $0f) | ((CHAN & $03) << 5) ;volume
	out ($7f), A
.ENDM

.MACRO psg_noise_set ARGS TYPE, VOL

	ld A, %11100000 | (TYPE & $07) ;low bits of tone
	out ($7f), A
	
	ld A, %11110000 | (VOL & $0f) ;volume
	out ($7f), A

.ENDM